unit FObjectlist;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QGrids, QExtCtrls, UStandard, QButtons, QComCtrls;

type
  TMain = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    SaveButton: TSpeedButton;
    color: TColorDialog;
    SpeedButton3: TSpeedButton;
    SortButton: TSpeedButton;
    InsertButton: TSpeedButton;
    ColorDialog: TColorDialog;
    ColNeuPanel: TPanel;
    neugrid: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SortButtonClick(Sender: TObject);
    procedure InsertButtonClick(Sender: TObject);
    procedure neugridClick(Sender: TObject);
    procedure ColNeuPanelClick(Sender: TObject);
  private
  public
    procedure WriteNeuListe (li:TStringList; sort: boolean);
    procedure ReadNeuListe  (li:TStringList);
    procedure SaveListe;
    procedure LoadListe;
  end;

var
  Main: TMain;

implementation

uses FOHelpform;

{$R *.xfm}

procedure TMain.ReadNeuListe;
var i,j,cnt,typ: integer;
    ss: String;
begin
  for i:=0 to neugrid.colcount-1 do for j:=1 to neugrid.rowcount-1
    do neugrid.cells[i,j]:='';
  cnt:=0;
  if li.Count>0 then for i:=0 to li.count-1 do begin
    ss:=li[i];
    if ParsStr(ss,'struct')='obj' then begin
      inc(cnt);
      typ := ParsInt (ss,'type',0);
      neugrid.cells[0,cnt]:=IntToStr (typ);;
      neugrid.cells[1,cnt]:=ParsStr(ss,'name');
      neugrid.cells[2,cnt]:=ParsStr(ss,'trivname');
      neugrid.cells[3,cnt]:=ParsStr(ss,'cup');
      neugrid.cells[4,cnt]:=ParsStr(ss,'grp');
      neugrid.cells[5,cnt]:=ParsStr(ss,'node');
      neugrid.cells[6,cnt]:=ParsStr(ss,'shape');
      neugrid.cells[7,cnt]:=ParsStr(ss,'xl');
      neugrid.cells[8,cnt]:=ParsStr(ss,'xr');
      neugrid.cells[9,cnt]:=ParsStr(ss,'yt');
      neugrid.cells[10,cnt]:=ParsStr(ss,'yb');
      neugrid.cells[11,cnt]:=ParsStr(ss,'pos');
      neugrid.cells[12,cnt]:=ParsStr(ss,'scale');
      neugrid.cells[13,cnt]:=ParsStr(ss,'rot');
      neugrid.cells[14,cnt]:=ParsStr(ss,'shad');
      neugrid.cells[15,cnt]:=ParsStr(ss,'def');
      neugrid.cells[16,cnt]:=ParsStr(ss,'red');
      neugrid.cells[17,cnt]:=ParsStr(ss,'grn');
      neugrid.cells[18,cnt]:=ParsStr(ss,'blue');
    end;
  end;
end;

procedure TMain.WriteNeuListe; {----------------------------------}
var i: integer;
    ss,typ: String;
begin
  li.Clear;
  if sort then li.sorted:=true else li.sorted:=false;
  for i:=1 to neugrid.Rowcount-1 do begin
    if neugrid.cells[0,i]<>'' then begin
      ss:='[struct]obj';
      typ:=neugrid.cells[0,i];
      if sort then while length(typ)<4 do typ:='0'+typ;
      ss:=ss+'[type]'+typ;
      ss:=ss+'[name]'+neugrid.cells[1,i];
      ss:=ss+'[trivname]'+neugrid.cells[2,i];
      ss:=ss+'[cup]'+ neugrid.cells[3,i];
      ss:=ss+'[grp]'+ neugrid.cells[4,i];
      ss:=ss+'[node]'+ neugrid.cells[5,i];
      ss:=ss+'[shape]'+ neugrid.cells[6,i];
      ss:=ss+'[xl]'+ neugrid.cells[7,i];
      ss:=ss+'[xr]'+ neugrid.cells[8,i];
      ss:=ss+'[yt]'+ neugrid.cells[9,i];
      ss:=ss+'[yb]'+ neugrid.cells[10,i];
      ss:=ss+'[pos]'+ neugrid.cells[11,i];
      ss:=ss+'[scale]'+ neugrid.cells[12,i];
      ss:=ss+'[rot]'+ neugrid.cells[13,i];
      ss:=ss+'[shad]'+ neugrid.cells[14,i];
      ss:=ss+'[def]'+ neugrid.cells[15,i];

      ss:=ss+'[red]'+ neugrid.cells[16,i];
      ss:=ss+'[grn]'+ neugrid.cells[17,i];
      ss:=ss+'[blue]'+ neugrid.cells[18,i];
      li.Add(ss);
    end;
  end;
end;

procedure TMain.SaveListe;
var fi:TStringList;
begin
  fi:=TStringList.Create;
  fi.Add('[struct]HDR');
  WriteNeuListe(fi,false);
  fi.SaveToFile(ProgDir+'res/objects.lst');
  fi.Free;
end;

procedure TMain.LoadListe;
var fi:TStringList;
begin
  if FileExists(ProgDir+'res/objects.lst') then begin
    fi:=TStringList.Create;
    fi.LoadFromFile(ProgDir+'res/objects.lst');
    ReadNeuListe(fi);
    fi.Free;
  end;
end;

procedure TMain.FormCreate(Sender: TObject);
begin
  top:=0; left:=0; height:=560; width:=960;
end;

procedure TMain.FormShow(Sender: TObject);
begin
  neugrid.colwidths[0]:=32;
  neugrid.colwidths[1]:=140;
  neugrid.colwidths[2]:=140;
  neugrid.colwidths[3]:=32;
  neugrid.colwidths[4]:=32;
  neugrid.colwidths[5]:=32;
  neugrid.colwidths[6]:=40;
  neugrid.colwidths[7]:=32;
  neugrid.colwidths[8]:=32;
  neugrid.colwidths[9]:=32;
  neugrid.colwidths[10]:=32;
  neugrid.colwidths[11]:=32;
  neugrid.colwidths[12]:=32;
  neugrid.colwidths[13]:=32;
  neugrid.colwidths[14]:=32;
  neugrid.colwidths[15]:=200;
  neugrid.colwidths[16]:=0;
  neugrid.colwidths[17]:=0;
  neugrid.colwidths[18]:=0;

  neugrid.cells[0,0]:='type';
  neugrid.cells[1,0]:='name';
  neugrid.cells[2,0]:='trivial name';
  neugrid.cells[3,0]:='cup';
  neugrid.cells[4,0]:='grp';
  neugrid.cells[5,0]:='node';
  neugrid.cells[6,0]:='shape';
  neugrid.cells[7,0]:='xl';
  neugrid.cells[8,0]:='xr';
  neugrid.cells[9,0]:='yt';
  neugrid.cells[10,0]:='yb';
  neugrid.cells[11,0]:='pos';
  neugrid.cells[12,0]:='scal';
  neugrid.cells[13,0]:='rot';
  neugrid.cells[14,0]:='shad';
  neugrid.cells[15,0]:='defaults';
  neugrid.cells[16,0]:='red';
  neugrid.cells[17,0]:='grn';
  neugrid.cells[18,0]:='blue';

  LoadListe;
end;

procedure TMain.FormDestroy(Sender: TObject);
begin
  begin end;
end;

procedure TMain.SaveButtonClick(Sender: TObject);
begin
  SaveListe;
end;

procedure TMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//  SaveListe;
end;

procedure TMain.SpeedButton3Click(Sender: TObject);
begin
  HelpForm.ShowModal;
end;

procedure TMain.SortButtonClick(Sender: TObject);
var fi:TStringList;
begin
  fi:=TStringList.Create;
  WriteNeuListe(fi,true);
  ReadNeuListe(fi);
  fi.Free;
end;

procedure TMain.InsertButtonClick(Sender: TObject);
var idx,i,j: integer;
begin
  idx:=neugrid.row;
  for j:=neugrid.rowcount-1 downto idx+1 do begin
    for i:=0 to neugrid.ColCount-1 do begin
      neugrid.cells[i,j]:=neugrid.cells[i,j-1];
    end;
  end;
  for i:=0 to neugrid.ColCount-1 do neugrid.cells[i,idx]:='';
end;

procedure TMain.neugridClick(Sender: TObject);
var idx,r,g,b:integer;
begin
  idx:=neugrid.row;
  r:=Str_int(neugrid.cells[16,idx],0);
  g:=Str_int(neugrid.cells[17,idx],0);
  b:=Str_int(neugrid.cells[18,idx],0);
  ColNeuPanel.color:=cCol(r,g,b);
end;

procedure TMain.ColNeuPanelClick(Sender: TObject);
var idx,r,g,b:integer;
    col:TColor;
begin
  idx:=neugrid.row;
  if (idx<1) or (idx>=neugrid.rowcount) then exit;
  ColorDialog.Color:=ColNeuPanel.Color;
  if ColorDialog.Execute then begin
    col:=ColorDialog.Color;
    ColNeuPanel.color:=col;
    r:=cRed(col);
    g:=cGreen(col);
    b:=cBlue(col);
    neugrid.cells[16,idx]:=IntToStr(r);
    neugrid.cells[17,idx]:=IntToStr(g);
    neugrid.cells[18,idx]:=IntToStr(b);
  end;
end;

end.
