unit UObjects;

interface
uses
  QGraphics, Types, SysUtils, Libc, Classes, Math, QDialogs, UTuxBase,
  UStandard;

procedure O_PaintOPixel   (x, y: integer; col: TColor);
procedure O_UnpaintOPixel (x, y: integer);
function  O_GetObjStr       (typ: integer): String;
function  O_GetObjCol       (typ: integer): TColor;
function  O_DeleteObject  (x, y: integer): integer;


implementation

procedure O_PaintOPixel; {-------------------------------------}
var ix, iy: integer;
begin
  if (x < 0) or (x >= iiWidth) or (y < 0) or (y >= iiHeight) then exit;
  for ix := 0 to mpScale-1 do for iy := 0 to mpScale-1 do begin
    MMap.Canvas.pixels [x * mpScale + ix, y * mpScale + iy] := col;
  end;
end;

procedure O_UnpaintOPixel; {-----------------------------------}
var ix, iy, xx, yy: integer;
begin
  if (x < 0) or (x >= iiWidth) or (y < 0) or (y >= iiHeight) then exit;
  for ix := 0 to mpScale-1 do for iy := 0 to mpScale-1 do begin
    xx := x * mpScale + ix;
    yy := y * mpScale + iy;
    MMap.Canvas.pixels [xx, yy] := MMap2.Canvas.Pixels[xx, yy];
  end;
end;

function O_GetObjStr; {----------------------------------------}
var idx:integer;
begin
  idx := ParsInt (OTypIdx, IntToStr(typ), -1);
  if (idx>=0) and (idx<OList.count) then Result := OList[idx]
  else Result:='';
end;

function O_GetObjCol; {------------------------------------------}
var idx, r, g, b:integer;
    ss: String;
begin
  idx := ParsInt (OTypIdx, IntToStr (typ), -1);
  if (idx >= 0) and (idx < OList.count) then begin
    ss := OList[idx];
    r := ParsInt (ss, 'red', 0);
    g := ParsInt (ss, 'green', 0);
    b := ParsInt (ss, 'blue', 0);
    Result := cCol (r, g, b);
  end else Result := clBlack;
end;

function O_DeleteObject; {-------------------------------------}
var idx: integer;
    ss, areaflag: String;
begin
  if (x < 0) or (x >= iiWidth) or (y < 0) or (y >= iiHeight) then begin
    Result := 0;
  end else begin;
    idx := ParsInt (OIdx, IntToStr(x) + '-' + IntToStr(y), -1);
    if (idx >= 0) and (idx < OArr.Count) then begin // an object found at this position
      ss := OArr[idx];
      areaflag := ParsStr (ss, 'shape');
      if (areaflag = 'a') or (areaflag = 'x') or (areaflag = 'y') then begin
        Result := 2
      end else begin
        Result := 1;
      end;
      OArr[idx] := 'Del';
      SetParsInt (OIdx, IntToStr(x) + '-' + IntToStr(y), -1);
    end else Result := 0;
  end;
end;



end.
