unit USpecial;

{---------------} interface {----------------------------------}

uses SysUtils, QGraphics, Classes, Types, Math, UStandard,
QComCtrls, UTuxBase, UMaps;

var specPar: integer;
    specStr: String;

procedure MaskEx   (width, height, ex: integer);
procedure RandomEx (actstr: String);
function  IsMaskLine    (y, width: integer): boolean;
function  FindFirstLine (width, height: integer): integer;
function  FindLastLine  (width, height: integer): integer;

{----------------} implementation {----------------------------}

function IsMaskLine;
var x:integer;
    res: boolean;
begin
  res:=false;
  for x:= 0 to width-1 do if MaskArr[y,x]>0 then res:=true;
  Result := res;
end;

function FindFirstLine;
var y: integer;
    found: boolean;
begin
  y:=-1;
  repeat
    inc (y);
    found := IsMaskLine (y,width);
  until found or (y=height-1);
  if found then Result:=y else Result := -1;
end;

function FindLastLine;
var y: integer;
    found: boolean;
begin
  y:=height;
  repeat
    dec (y);
    found := IsMaskLine (y,width);
  until found or (y=0);
  if found then Result:=y else Result := -1;
end;

procedure MaskEx; {---------------------------------------}
var cnt, diff, x, y, val, val2: integer;
    first, last, middle, av, sum, midgrey: integer;
    heightdiff, greydiff: integer;
begin
  if ex = 1 then begin // heller
    for y:=0 to height-1 do for x:=0 to width-1 do begin
      if MaskArr[y,x]> 0 then begin
        val:=EArr[y,x] + 10;
        if val>255 then val := 255;
        EArr[y,x]:=val;
      end;
    end;

  end else if ex = 2 then begin // dunkler
    for y := 0 to height-1 do for x := 0 to width-1 do begin
      if MaskArr [y,x] > 0 then begin
        val:=EArr[y,x] - 10;
        if val < 0 then val := 0;
        EArr[y,x]:=val;
      end;
    end;

  end else if ex = 3 then begin  // waagerecht
    first := FindFirstLine (width, height);
    last := FindLastLine (width, height);
    if (first >= 0) and (last >= 0) and (last > first) then begin
      middle := (last + first) div 2;
      sum := 0;
      cnt := 0;
      for x := 0 to width-1 do if MaskArr [middle, x] > 0 then begin
        inc (cnt);
        sum := sum + EArr [middle, x];
      end;
      if cnt = 0 then for x := 0 to width-1 do begin
        inc (cnt);
        sum := sum + EArr [middle, x];
      end;
      midgrey := round (sum / cnt);

      heightdiff := round (tan ((iiAngle - mpBasementAngle) * pi / 180) * (middle - first) * iiCourseLength / iiHeight);
      greydiff := round (heightdiff * 256 / iiScale);
      if first < middle then for y := first to middle-1 do begin
        diff := y - middle;
        for x := 0 to width-1 do if MaskArr [y, x] > 0 then begin
          val := midgrey + round (greydiff * diff / (last - middle));
          if val < 0 then val := 0;
          EArr[y,x] := val;
        end;
      end;

      heightdiff := round (tan ((iiAngle - mpBasementAngle) * pi / 180) * (last - middle) * iiCourseLength / iiHeight);
      greydiff := round (heightdiff * 256 / iiScale);
      if last > middle then for y := middle + 1 to last do begin
        diff := y - middle;
        for x := 0 to width-1 do if MaskArr [y, x] > 0 then begin
          val := midgrey + round (greydiff * diff / (last - middle));
          if val > 255 then val := 255;
          EArr[y,x] := val;
        end;
      end;

      for x := 0 to width-1 do if MaskArr [middle, x] > 0 then EArr[middle, x] := midgrey;
    end;
  end;
end;

procedure RandomEx; {------------------------------------------}
const actidx: String = '[fill]1[spot]2[line]3';
var mincnt, maxcnt, cnt, arcnt, cntmult: integer;
    act, press: integer;
    i, grey, val, x, y, left, right, top, bottom: integer;
    minsize, maxsize, brushsize: integer;
    minval, maxval: integer;
    xpos, ypos, xpos2, ypos2: integer;
    minxlen, maxxlen, minylen, maxylen: integer;
begin
  act := ParsInt (actidx, ParsStr (actstr, 'act'), 0);
  mincnt := ParsInt (actstr, 'cnt-', 1);
  maxcnt := parsInt (actstr, 'cnt+', 1);
  cnt := XRandom (mincnt, maxcnt);
  arcnt := ParsInt (actstr, 'arcnt', 0);
  if arcnt > 0 then begin
    cntmult := round (iiHeight * iiWidth / 25000);
    cnt := cnt * cntmult;
  end;

  if (act > 0) and (cnt > 0) then begin
    left := ParsInt (actstr, 'x-', 0);
    if (left < 0) or (left > 100) then left := 0;
    right := ParsInt (actstr, 'x+', 100);
    if (right < 0) or (right > 100) then right := 100;
    top := ParsInt (actstr, 'y-', 0);
    if (top < 0) or (top > 100) then top := 0;
    bottom := ParsInt (actstr, 'y+', 100);
    if (bottom < 0) or (bottom > 100) then bottom := 100;
    if left >= right then begin
      left := 0;
      right := 100;
    end;
    if top >= bottom then begin
      top := 0;
      bottom := 100;
    end;
    left := left * iiWidth div 100;
    top := top * iiHeight div 100;
    right := right * iiWidth div 100;
    bottom := bottom * iiHeight div 100;

    val := ParsInt (actstr, 'val', 0);
    case act of
      1: begin // fill
         if val < 0 then val := 0;
         if val > 255 then val := 255;
         for y := top to bottom do for x := left to right do EArr[y,x] := val;
         end;
      2: begin //spot
         for i := 1 to cnt do begin
           minval := ParsInt (actstr, 'val-', 0);
           maxval := ParsInt (actstr, 'val+', 255);
           mpElevGrey := XRandom (minval, maxval);
           press := ParsInt (actstr, 'press', 50);
           minsize := ParsInt (actstr, 'size-', 3);
           maxsize := ParsInt (actstr, 'size+', 10);
           brushsize := XRandom (minsize, maxsize);
           xpos := XRandom (left, right);
           ypos := XRandom (top, bottom);
           mpBrushPar.size := brushsize;
           mpElevBrush := 16;  // PaintBrushSpot has to use a soft brush
           GenerateBrush (brushsize, press, true);
           PaintBrushSpot (xpos, ypos);
         end;
         end;
      3: begin // line
         for i := 1 to cnt do begin
           minval := ParsInt (actstr, 'val-', 0);
           maxval := ParsInt (actstr, 'val+', 255);
           mpElevGrey := XRandom (minval, maxval);

           press := ParsInt (actstr, 'press', 50);

           minsize := ParsInt (actstr, 'size-', 3);
           maxsize := ParsInt (actstr, 'size+', 10);
           brushsize := XRandom (minsize, maxsize);

           minxlen := ParsInt (actstr, 'xdist-', 1);
           maxxlen := ParsInt (actstr, 'xdist+', 1);
           minylen := ParsInt (actstr, 'ydist-', 1);
           maxylen := ParsInt (actstr, 'ydist+', 1);
           xpos := XRandom (left, right);
           ypos := XRandom (top, bottom);

           if XRandom (1,2) = 1 then xpos2 := xpos + XRandom (minxlen, maxxlen)
             else xpos2 := xpos - XRandom (minxlen, maxxlen);
           if XRandom (1,2) = 1 then ypos2 := ypos + XRandom (minylen, maxylen)
             else ypos2 := ypos - XRandom (minylen, maxylen);


           mpBrushPar.size := brushsize;
           mpElevBrush := 16;  // PaintBrushSpot has to use a soft brush
           GenerateBrush (brushsize, press, true);
           PaintBrushTrack (xpos, ypos, xpos2, ypos2, xpos2 - xpos, ypos2 - ypos);
         end;
         end;
    end;
  end;
end;


end.
