unit UTest1;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  Math, QDialogs, QStdCtrls, QExtCtrls, UStandard, QButtons, QComCtrls;

const
  xscale: integer = 2;
  yscale: integer = 2;
type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Register: TPageControl;
    tabelle: TTabSheet;
    grafik: TTabSheet;
    liste: TListBox;
    Panel2: TPanel;
    ScrollBox1: TScrollBox;
    client: TPaintBox;
    Testliste: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure clientPaint(Sender: TObject);
  private
  public
    list1, list2: TStringlist;
    timelist: TStringlist;

    procedure Analyse;
    procedure PaintClient;
    procedure PaintPoints;
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  top:=0; left := 0; height := 560; width := 800;
  list1 := TStringList.Create;
  list2 := TStringList.Create;
  timelist := TStringlist.Create;
  DecimalSeparator := '.';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  list1.Free;
  list2.Free;
  Timelist.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  list1.LoadFromFile (ProgDir + 'res' + SEP + 'easy.tcl');
  Analyse;
end;

procedure TForm1.Analyse; {====================================}
var i,po: integer;
    ss,a,b: String;
    posit1, posit2: String;
    scale, rotation: String;
    time1, time2, timediff: double;
    y1, y2, ydiff: double;
    x1, x2, xdiff: double;
    z1, z2, zdiff: double;
    raumdiag, diag, weg, s, sy: double;
    xrot, zrot, yrot, zwinkel: double;
    korr, diff, err, oldwinkel, newwinkel: double;
    yabw, zabw, quot: double;

procedure DivideParams (par: String); {........................}
var anz: integer;
begin
  a := ' '+ BareStr (ParsStr (b, par));
  if a <> ' ' then begin
     anz := 0;
     repeat
       po := pos (' ',a);
       if po > 0 then begin
         inc (anz);
         delete (a, po, 1);
         insert ('{' + IntToStr(anz) + '}', a, po);
       end;
     until po = 0;
     SetParsStr (b, par, a);
  end;
end;

procedure ClearParams (par: String); {.........................}
begin
  a := BareStr (ParsStr (b, par));
  SetParsStr (b, par, a);
end;

begin {........................................................}

  for i := 0 to list1.Count-1 do list1[i] := BareStr (list1[i]);

  for i := list1.Count-1 downto 1 do begin
    a := list1[i-1];
    b := list1[i];
    if (a <> '') and (b <> '') then begin
      if a[length(a)] = '\' then begin
        delete (a, length(a), 1);
        list1[i-1] := a + b;
        list1[i] := '';
      end;
    end;
  end;

  for i := list1.count-1 downto 0 do if list1[i] = '' then list1.delete(i);

  // Lschen von End-"\"
  (*  for i := 0 to list1.count-1 do begin
    a := list1[i];
    if a[length(a)] = '\' then delete (a, length(a), 1);
    list1[i] := a;
  end;*)

  for i := 0 to list1.Count-1 do begin
    if pos ('{s_aitarget}', list1[i]) <> 0 then list2.Add (list1[i]);
  end;

  for i := 0 to list2.Count-1 do begin
    po := pos ('{-time}', list2[i]);
    if po <> 0 then list2[i] := copy (list2[i], po, 200);
  end;

  for i := 0 to list2.Count-1 do begin
    a := list2[i];
    a := changepart (a, '{-time}', '[-time]');
    a := changepart (a, '{-position}', '[-position]');
    a := changepart (a, '{-rotation}', '[-rotation]');
    a := changepart (a, '{-scale}', '[-scale]');
    a := changepart (a, '{-brake}', '[-brake]');
    while pos ('{', a) <> 0 do delete (a, pos('{', a), 1);
    while pos ('}', a) <> 0 do delete (a, pos('}', a), 1);
    list2[i] := a;
  end;

 for i := 0 to list2.Count-1 do begin
    b := list2[i];
    ClearParams ('-time');
    ClearParams ('-brake');
    DivideParams ('-position');
    DivideParams ('-scale');
    DivideParams ('-rotation');
    list2[i] := b;
  end;

  {- - - - - - - - - - - - - - - - - - - - - - - - -}

  err := 0;
  oldwinkel := 24;
  timelist.Clear;
  for i := 0 to list2.count-2 do begin
    time1 := ParsFloat (list2[i],'-time',0);
    time2 := ParsFloat (list2[i+1],'-time',0);
    timediff := time2 - time1;

    posit1 := ParsStr (list2[i], '-position');
    posit2 := ParsStr (list2[i+1], '-position');
    y1 := ParsFloat2 (posit1, '3',2);
    y2 := ParsFloat2 (posit2, '3',2);
    x1 := ParsFloat2 (posit1, '1',2);
    x2 := ParsFloat2 (posit2, '1',2);
    z1 := ParsFloat2 (posit1, '2',2);
    z2 := ParsFloat2 (posit2, '2',2);

    ydiff := y2 - y1;
    xdiff := x2 - x1;
    zdiff := z2 - z1;

    diag := sqrt (zdiff * zdiff + ydiff * ydiff);
//    raumdiag := sqrt (zdiff * zdiff + diag * diag);
    weg := ydiff;

    scale := ParsStr (list2[i], '-scale');
    rotation := ParsStr (list2[i], '-rotation');

    s := ParsFloat2 (scale, '3',0);
//    xrot := ParsFloat2 (rotation, '1',0);
    yrot := ParsFloat2 (rotation, '3',0);
    zrot := ParsFloat2 (rotation, '2',0);

    if zrot < 0 then zrot := zrot + 360;
    if yrot < 0 then yrot := yrot + 360;
    zabw := abs(180 - zrot);
    yabw := abs(yrot - 180);
    quot := yabw / zabw;

    newwinkel := arctan (zdiff / ydiff) * 180 / pi;
//    zwinkel := (8 * 24 + 2 * newwinkel) / 10;
    zwinkel := newwinkel;
    oldwinkel := newwinkel;

    diff := abs (xrot - zwinkel);
    err := err + diff;

    ss := '';
//    ss := ss + '  [x] '+ Float_Str (x1,2);
//    ss := ss + '  [y]  '+ Float_Str (y1,2);
//    ss := ss + '  [z]  '+ Float_Str (z1,2);

//    ss := ss + '  [timediff]  ' + Float_Str (timediff,2);
//    ss := ss + '  [xdiff]  '+ Float_Str (xdiff,2);
//    ss := ss + '  [ydiff]  '+ Float_Str (ydiff,2);
//    ss := ss + '  [zdiff]  '+ Float_Str (zdiff,2);
//    ss := ss + '  [zrot]  ' + Float_Str (zrot,2);
    ss := ss + '  [zrot]  ' + Float_Str (zrot,2);
    ss := ss + '  [yrot]  ' + Float_Str (yrot,2);
    ss := ss + '  [z-abweichung]  ' + Float_Str (zabw,2);
    ss := ss + '  [y-abweichung]  ' + Float_Str (yabw,2);
    ss := ss + '  [quotient]  ' + Float_Str (quot,2);

//    ss := ss + '  [zwinkel]  ' + Float_Str (zwinkel,2);
//    ss := ss + '  [diff]  ' + Float_Str (diff,2);

//    ss := ss + '  [diff]  ' + Float_Str (zwinkel-zrot,2);
//    ss := ss + '  [xwinkel]  ' + Float_Str (xtan,2);
//    ss := ss + '  [weg]  ' + Float_Str (weg, 2);
//    ss := ss + '  [scale]  ' + Float_Str (s,2);
//    ss := ss + '  [scale_self]  ' + Float_Str (raumdiag/timediff,2);

    timelist.add (ss);
  end;
  timelist.add (Float_str (err,2)+'  '+inttostr(list2.count));
  client.height := 4000;
  client.width := 1000;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  liste.items := list1;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  liste.items := list2;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  liste.items := timelist;
end;
procedure TForm1.PaintClient;
var i: integer;
    x,y,z: integer;
    c: TCanvas;
    ss: String;
begin
  c := Client.Canvas;
  c.pen.color := clBlack;
  testliste.clear;
  for i := 0 to timelist.count-1 do begin
    ss := timelist[i];
    z:= -round(ParsFloat (ss,'z',0));
    y:= abs(round(ParsFloat (ss,'y',0)));
    if i=0 then c.moveTo (z * xscale, y * yscale)
      else  c.lineto (z * xscale, y * yscale);
  end;
  PaintPoints;
end;

procedure TForm1.PaintPoints;
var i: integer;
    x,y, xpos,ypos: integer;
    c: TCanvas;
    zrot: double;
    ss: String;
    xdiff, ydiff: integer;
begin
  c := Client.Canvas;
  c.pen.color := clYellow;
  for i := 0 to timelist.count-1 do begin
(*    ss := timelist[i];
    x:= round(ParsFloat (ss,'x',0));
    y:= abs(round(ParsFloat (ss,'y',0)));
    zrot := ParsFloat (ss,'zrot',0);
    zrot := zrot * pi / 180;
    ydiff := 100;
    xdiff := -round (tan (zrot) * ydiff);
    testliste.items.add(Float_str(zrot,2)+'  '+float_str(tan(zrot),2));
    ydiff := ydiff * yscale div 20;
    xdiff := xdiff * xscale div 20;
    xpos := x * xscale;
    ypos := y * yscale;
    c.moveto (xpos, ypos);
    c.lineto (xpos+xdiff, ypos+ydiff);*)
    c.pixels [xpos, ypos]:=clWhite;
  end;
end;

procedure TForm1.clientPaint(Sender: TObject);
begin
  PaintClient;
end;

end.
